//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F6F20580010.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F6F20580010.cm

//## begin module%3F6F20580010.cp preserve=no
//## end module%3F6F20580010.cp

//## Module: Cluster%3F6F20580010; Package body
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/Cluster.cxx

//## begin module%3F6F20580010.additionalIncludes preserve=no
//## end module%3F6F20580010.additionalIncludes

//## begin module%3F6F20580010.includes preserve=yes
#include <XSContainer.h>
#include <XSsymbol.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/GlobalContainer/DataSetTypes.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSstreams.h>
#include <cmath>
//## end module%3F6F20580010.includes

// DataContainer
#include <XSModel/GlobalContainer/DataContainer.h>
// ClusterRegion
#include "ClusterRegion.h"
// PsfImage
#include <PsfImage.h>
// XRTResponse
#include <XRTResponse.h>
// Cluster
#include <Cluster.h>


//## begin module%3F6F20580010.declarations preserve=no
//## end module%3F6F20580010.declarations

//## begin module%3F6F20580010.additionalDeclarations preserve=yes
using namespace XSContainer;
extern "C" double Get_gis_eff(double lo, double hi, double be, int correct);
//## end module%3F6F20580010.additionalDeclarations


// Class Cluster::ClusterError 

Cluster::ClusterError::ClusterError (const string& msg)
  //## begin Cluster::ClusterError::ClusterError%3FCBC4280045.hasinit preserve=yes
  : YellowAlert("Cluster Model Error: ")
  //## end Cluster::ClusterError::ClusterError%3FCBC4280045.hasinit
  //## begin Cluster::ClusterError::ClusterError%3FCBC4280045.initialization preserve=yes
  //## end Cluster::ClusterError::ClusterError%3FCBC4280045.initialization
{
  //## begin Cluster::ClusterError::ClusterError%3FCBC4280045.body preserve=yes
  std::cerr << msg << std::endl;
  //## end Cluster::ClusterError::ClusterError%3FCBC4280045.body
}


// Class Cluster 

//## begin Cluster::PI%404748F2038C.attr preserve=no  private: static Real {U} 4.*atan(1.)
Real Cluster::s_PI = 4.*atan(1.);
//## end Cluster::PI%404748F2038C.attr

//## begin Cluster::psfFileName%404797790080.attr preserve=no  private: static const string {U} string("allpsf.nosm.fits")
const string Cluster::s_psfFileName = string("allpsf.nosm.fits");
//## end Cluster::psfFileName%404797790080.attr

//## begin Cluster::xrtFileName%4052160E033D.attr preserve=no  private: static const string {U} string("xrt_ea.fits")
const string Cluster::s_xrtFileName = string("xrt_ea.fits");
//## end Cluster::xrtFileName%4052160E033D.attr

Cluster::Cluster (const string& name)
  //## begin Cluster::Cluster%405B1B3E0268.hasinit preserve=yes
  : MixBase(name),
      m_alpha(.0),
      m_beta(.0),
      m_core(.0),
      m_sbModelType(0),
      m_factArray(),
      m_parametersAreFrozen(true),
      m_regions(),
      m_instInUse(),
      m_psfEnergy(),
      m_modelName(),
      m_engIndices(),
      m_psfImage(0),
      m_weight(),
      m_xrtResponse(0),
      m_dataChanged(false),
      m_allEnergies(),
      m_centers(),
      m_psfArray()
  //## end Cluster::Cluster%405B1B3E0268.hasinit
  //## begin Cluster::Cluster%405B1B3E0268.initialization preserve=yes
  //## end Cluster::Cluster%405B1B3E0268.initialization
{
  //## begin Cluster::Cluster%405B1B3E0268.body preserve=yes
  const size_t nPSFE = 10;
  m_psfEnergy.resize(nPSFE);
  for (size_t i=0; i<nPSFE; ++i)
  {
     m_psfEnergy[i] = i + 1.5;
  }
  //## end Cluster::Cluster%405B1B3E0268.body
}


Cluster::~Cluster()
{
  //## begin Cluster::~Cluster%3F6F1DC503A1_dest.body preserve=yes
   clearRegions();
   delete m_psfImage;
   delete m_xrtResponse;
  //## end Cluster::~Cluster%3F6F1DC503A1_dest.body
}



//## Other Operations (implementation)
void Cluster::initialize (const std::vector<Real>& params, const std::string& modelName)
{
  //## begin Cluster::initialize%3F6F1DD80292.body preserve=yes
  //This function does a complete initialize.  This is what should
  // be called anytime datasets->Notify() is sent, or whenever
  // the model containing this component is first constructed.
  clearRegions();
  
  verifyData();
  // m_psfImage and m_xrtResponse are only created once, and
  // will last the duration of Cluster object.
  if (!m_psfImage)
  {
     m_psfImage = new PsfImage(s_psfFileName);
  }
  if (!m_xrtResponse)
  {
     m_xrtResponse = new XRTResponse(s_xrtFileName);
  }
  m_modelName = modelName;
  size_t nReg = datasets->numberOfGroups();
  size_t nInst = ClusterRegion::NINST();
  m_regions.resize(nInst);
  m_instInUse.resize(nInst,false);
  
  for (size_t i=0; i<nInst; ++i)
  {
     m_regions[i].resize(nReg, static_cast<ClusterRegion*>(0));
  }
  try
  {
     DataArrayConstIt it = datasets->dataArray().begin();
     DataArrayConstIt itEnd = datasets->dataArray().end();
     while (it != itEnd)
     {
        // NOTE: dG is not set to match the XFLT0001 keyval for 
        // region number, though it should be one-to-one with it.
        size_t dG = it->second->dataGroup();
        string fileName = it->second->getFullPathName();
        // Assumption is that only Type I files are allowed.
        size_t specNum = it->second->spectralData()->spectrumNumber();
        int iReg = static_cast<int>(it->second->spectralData()->xflt(1));
        std::auto_ptr<ClusterRegion> tmp(new ClusterRegion(fileName,iReg,specNum));
        size_t iInst = tmp->instrument();
        m_regions[iInst][dG-1] = tmp.release();
        m_instInUse[iInst] = true;
        ++it;
     }
     calcCentersOfEmission();
     calcEngIndices();
     m_dataChanged = true;
     initializeForFit(params, true);
  }
  catch (YellowAlert&)
  {
     clearRegions();
     m_psfArray.clear();
     throw;
  }
  //## end Cluster::initialize%3F6F1DD80292.body
}

void Cluster::perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError)
{
  //## begin Cluster::perform%3F7DE8A3018D.body preserve=yes
  bool isError(!fluxError.empty());
  doPerform(flux, false);
  if (isError)
  {
     doPerform(fluxError, true);
  }
  //## end Cluster::perform%3F7DE8A3018D.body
}

void Cluster::verifyData () const
{
  //## begin Cluster::verifyData%3FBD058400CD.body preserve=yes
  if (!datasets->dataArray().size())
  {
     throw NoDataPresent("");
  }
  
  // Check that these conditions are met: 
  // 1. Different data groups are assigned to each region.
  // 2. All spectra in data group are in the same region, REGARDLESS
  //     OF INSTRUMENT.
  const size_t nGroups = datasets->numberOfGroups();
  IntegerArray groupRegion(nGroups, -1);
  DataArrayConstIt it = datasets->dataArray().begin();
  DataArrayConstIt itEnd = datasets->dataArray().end();
  while (it != itEnd)
  {
     size_t dG = it->second->dataGroup();
     if (it->second->isMultiple())
     {
        string msg("ASCA mix model can only be used with data from OGIP-TYPE I files.");
        throw ClusterError(msg);
        //SpectralDataMap::const_iterator itDs = 
        //        it->second->multiSpectralData().begin();
        //SpectralDataMap::const_iterator itDsEnd =
        //        it->second->multiSpectralData().end();
        //while (itDs != itDsEnd)
        // {
        //   int iRegion = static_cast<int>(itDs->second->xflt(1));
        //   if (groupRegion[dG-1] == -1)
        //   {
        //      groupRegion[dG-1] = iRegion;
        //   }
        //   else if (groupRegion[dG-1] != iRegion)
        //  {
        //      string msg("To use ASCA mix model, all spectra in data group must belong");
        //      msg += "\nto same region.  Check spectra XFLT0001 key values.";
        //      throw ClusterError(msg);
        //   }
           // else OK, do nothing.
        //   ++itDs;
        // }
     }
     else
     {
	int iRegion = static_cast<int>(it->second->spectralData()->xflt(1));
        if (groupRegion[dG-1] == -1)
        {
           groupRegion[dG-1] = iRegion;
        }
        else if (groupRegion[dG-1] != iRegion)
        {
           string msg("To use ASCA mix model, all spectra in data group must belong");
           msg += "\nto same region.  Check spectra XFLT0001 key values.";
           throw ClusterError(msg);
        }
        // else OK, do nothing.
     }
     ++it;
  }
  //## end Cluster::verifyData%3FBD058400CD.body
}

void Cluster::initializeForFit (const std::vector<Real>& params, bool paramsAreFixed)
{
  //## begin Cluster::initializeForFit%3FBD05F503E4.body preserve=yes
  // This is the initialization that should be performed in response
  // to a fit command, or a fit update call.  It is a subset of the  
  // general initialize function.
  bool paramsChanged = changedParameters(params);
  m_parametersAreFrozen = paramsAreFixed;
  
  // If we got here immediately after first getting here from the 
  // initialize function (such as from the datasets->models->fit 
  // notify update chain), no problem. In that case, nothing below 
  // will be done. 
  if (paramsChanged || m_dataChanged)
  {
     m_alpha = params[0];
     m_beta = params[1];
     m_core = params[2];
     m_sbModelType = static_cast<int>(params[3]);
     clusterFact();
     m_dataChanged = false;
  }
  //## end Cluster::initializeForFit%3FBD05F503E4.body
}

void Cluster::clearRegions ()
{
  //## begin Cluster::clearRegions%3FBD0DB8024C.body preserve=yes
  size_t nInst = m_regions.size();
  for (size_t i=0; i<nInst; ++i)
  {
     std::vector<ClusterRegion*>& regions_i = m_regions[i];
     size_t nReg = regions_i.size();
     for (size_t j=0; j<nReg; ++j)
     {
        delete regions_i[j];
     }
  }
  m_regions.clear();  
  m_instInUse.clear(); 
  //## end Cluster::clearRegions%3FBD0DB8024C.body
}

void Cluster::calcCentersOfEmission ()
{
  //## begin Cluster::calcCentersOfEmission%40364377006E.body preserve=yes
  m_centers.resize(ClusterRegion::NINST());
  for (size_t i=0; i<ClusterRegion::NINST(); ++i)
  {
     std::pair<Real,Real>& center = m_centers[i];
     center.first = center.second = .0;
     const std::vector<ClusterRegion*>& instRegions = m_regions[i];
     size_t nReg = instRegions.size();
     Real xpos=.0, ypos=.0;
     int nTotalPix=0;
     if (m_instInUse[i])
     {
        for (size_t j=0; j<nReg; ++j)
        {
           if (instRegions[j])
           {
              int nPix = instRegions[j]->nPixInRegion();
              xpos += instRegions[j]->center().first*nPix;
              ypos += instRegions[j]->center().second*nPix;
              nTotalPix += nPix;
           }
        }
        if (nTotalPix)
        {
           center.first = xpos/(4.0*nTotalPix);
           center.second = ypos/(4.0*nTotalPix);
        }        
     }
  }
  if (tpout.maxChatter() >= 25)
  {
     const std::vector<string>& instNames = ClusterRegion::instrumentNames();
     size_t sz = instNames.size();
     tcout << "\nCluster centers:" << std::endl;
     for (size_t i=0; i<sz; ++i)
     {
        tcout << "  " << instNames[i] << ":  " << m_centers[i].first 
               << " , " << m_centers[i].second <<std::endl; 
     }
  }
  //## end Cluster::calcCentersOfEmission%40364377006E.body
}

void Cluster::clusterFact ()
{
  //## begin Cluster::clusterFact%403B72A5006A.body preserve=yes
  size_t nInst = ClusterRegion::NINST();
  size_t nReg = datasets->numberOfGroups();
  const size_t nPSFE = m_psfEnergy.size();
  const size_t nDIM = PsfImage::NDIM();
  const Real threshold = 1./32.;
  int nTotE = m_engIndices[nInst-1][nReg];
  m_factArray.resize(nReg*nTotE, .0);
  m_weight.resize(nPSFE*nReg, .0);
  m_psfArray.resize(nPSFE);
  for (size_t i=0; i<nPSFE; ++i)
  {
     m_psfArray[i].resize(nDIM*nDIM);
  }
  
  for (size_t inst=0; inst<nInst; ++inst)
  {
     if (m_instInUse[inst])
     {
        std::pair<Real,Real> optic = getOptic(inst);
        const std::pair<Real,Real>& centers_i = m_centers[inst];
        int nMap = ClusterRegion::instMapSizes()[inst];
        const int icen = (nMap + 1)/2;
        // Note center points are 1-based.
        // Loop over source map pixels.
        for (int iy=1; iy<=nMap; ++iy)
        {
           Real y = iy - centers_i.second;
           Real yoff = iy - optic.second;
           int iyOffset = (iy-1)*nMap;
           int jyLow=0, jyHigh=0;
           if (iy <= icen)
           {
              jyLow = 1;
              jyHigh = iy + (icen-1);
           }
           else
           {
              jyLow = iy - (icen-1);
              jyHigh = nMap;
           }
           for (int ix=1; ix<=nMap; ++ix)
           {
              Real x = ix - centers_i.first;
              Real xoff = ix - optic.first;
              int jxLow=0, jxHigh=0;
              if (ix <= icen)
              {
                 jxLow = 1;
                 jxHigh = ix + (icen-1);
              }
              else
              {
                 jxLow = ix - (icen-1);
                 jxHigh = nMap;
              }
              if (isPixInRegions(inst, ix, iy))
              {
                 Real theta=.0, phi=.0;
                 calcCoordinates(xoff, yoff, theta, phi);
                 if (theta <= 17.)
                 {
                    Real sbint = integrateSurfaceBrightness(x, y);
                    for (size_t iPSFE=0; iPSFE<nPSFE; ++iPSFE)
                    {
                      m_psfImage->calcPsf(m_psfEnergy[iPSFE], theta,
                            phi, m_psfArray[iPSFE]);
                    }
                    m_weight = 0.;
                    
                    // Loop over target map pixels.
                    // ix,iy,jx,jy, and therefore xpsf,ypsf are 1-based.
                    for (int jy=jyLow; jy<=jyHigh; ++jy)
                    {
                       int ypsf = icen - iy + jy;
                       int jyOffset = (jy-1)*nMap;
                       for (int jx=jxLow; jx<=jxHigh; ++jx)
                       {
                          int xpsf = icen - ix + jx;
                          int psfElem = (xpsf-1) + (ypsf-1)*nDIM;
                          // Loop over the target regions.
                          for (int jreg=0; jreg<nReg; ++jreg)
                          {
                             const ClusterRegion* cr = m_regions[inst][jreg];
                             if (cr)
                             {
                                int jregOffset = jreg*nPSFE;
                                const RealArray& regFrac = cr->instMapFractions();
                                Real regFrac_jxjy = regFrac[jx-1 + jyOffset];
                                if (regFrac_jxjy >= threshold)
                                {
                                   
                                   for (size_t iPSFE=0; iPSFE<nPSFE; ++iPSFE)
                                   {
                                      m_weight[iPSFE+jregOffset] += 
                                        m_psfArray[iPSFE][psfElem]*regFrac_jxjy;
                                   }
                                }
                             }
                             
                          } // end target regions loop
                       } // end target map x pixels loop
                    } // end target map y pixels loop
                    // Sum the contribution from this source pixel into 
                    // the appropriate element of the fact array. Interpolate
                    // on the weight array to get the PSF contribution at each
                    // energy. Multiply by the XRT effective area for this 
                    // source pixel.
                    const std::vector<int>& engIndices_i = m_engIndices[inst];
                    int nPsfe = m_psfEnergy.size();
                    for (int ireg=0; ireg<nReg; ++ireg)
                    {
                       const ClusterRegion* cr = m_regions[inst][ireg];
                       if (cr)
                       {
                          const RealArray& regFrac = cr->instMapFractions();
                          if (regFrac[ix-1+iyOffset] >= threshold)
                          {
                             int ilowE = engIndices_i[ireg];
                             int ihighE = engIndices_i[ireg+1];
                             int nE = ihighE - ilowE;
                             const RealArray& engs = m_allEnergies.find(ireg+1)->
                                        second->find(cr->spectrumNumber())->second;
                             int startFrom = 0;
                             for (int ie=1; ie<nE; ++ie)
                             {
                                Real centerE = (engs[ie-1] + engs[ie])/2.0;
                                Real frac0 = .0;
                                int iPsfe = findPsfEngBracket(centerE, startFrom);
                                if (iPsfe < 0)
                                {
                                   startFrom = 0;
                                   iPsfe = 0;
                                   frac0 = 1.0;
                                }
                                else if (iPsfe == nPsfe-1)
                                {
                                   startFrom = iPsfe;
                                   frac0 = 0.0;
                                   // decrement is necessary since we'll
                                   // be taking iPsfe+1 below.
                                   --iPsfe;
                                }
                                else
                                {
                                   startFrom = iPsfe;
                                   Real deltaE = m_psfEnergy[iPsfe+1] - 
                                                m_psfEnergy[iPsfe];
                                   frac0 = (m_psfEnergy[iPsfe+1] - centerE)/deltaE;
                                } 
                                Real frac1 = 1.0 - frac0;
                                Real effec = sbint*regFrac[ix-1 + iyOffset]*
                                   m_xrtResponse->ebinEffectiveArea(engs[ie-1],
                                   engs[ie], theta,.0);
                                for (int jreg=0; jreg<nReg; ++jreg)
                                {
                                   m_factArray[ilowE+ie-1 + jreg*nTotE] +=
                                        effec*(frac0*m_weight[iPsfe+nPsfe*jreg] +
                                        frac1*m_weight[iPsfe+1+nPsfe*jreg]);
                                }
                             } // end energy loop
                          } // end if regFrac greater than threshold
                       }  // end if cluster region exists
                    } // end ireg loop
                 } // end if theta <= 17.
              } // end if pixel in regions
           } // end source map x pixels loop
        } // end source map y pixels loop
        if (inst >= 2)
        {
           calcGISEfficiency(inst);
        }
     } // end if instrument in use
  } // end instrument loop
  m_psfArray.clear();
  
  //## end Cluster::clusterFact%403B72A5006A.body
}

void Cluster::calcEngIndices ()
{
  //## begin Cluster::calcEngIndices%4044F64A02D6.body preserve=yes
  size_t nReg = datasets->numberOfGroups();
  size_t nInst = ClusterRegion::NINST();
  m_allEnergies = models->gatherGroupEnergy(m_modelName);
  
  m_engIndices.resize(nInst);
  for (size_t i=0; i<nInst; ++i)
  {
     m_engIndices[i].resize(nReg+1, 0);
  }
  
  // First pass:  simply store the size of the energy arrays
  // found for each region for each instrument.
  
  // EnergyPointer is a map of a map of model energy arrays.
  // The outer map contains datagroups (regions), the inner
  // contains spectra (instruments).  
  for (size_t i=0; i<nInst; ++i)
  {
     if (m_instInUse[i])
     {
        for (size_t j=0; j<nReg; ++j)
        {
           const ClusterRegion* cr = m_regions[i][j];
           if (cr)
           {
              size_t dG = j+1;
              // If cr exists, we know there must be an energy
              // map for this data group number.
              const ArrayContainer& dgEnergies = *(m_allEnergies.find(dG)->second);
              size_t specNum = cr->spectrumNumber();
              size_t nE = dgEnergies.find(specNum)->second.size();
              m_engIndices[i][j] = static_cast<int>(nE);
           }
        }
     }
  }
  
  // Second pass:  now replace the energy array sizes with their
  // cumulative offset from the beginning of inst 0 dg 1.
  // Note that inner loop now goes over all nReg+1 elements rather
  // than just nReg as in first pass.
  int cumulative = 0;
  for (size_t i=0; i< nInst; ++i)
  {
     IntegerArray& engIndices_i = m_engIndices[i];
     for (size_t j=0; j<=nReg; ++j)
     {
        int currEnergySize = engIndices_i[j];
        engIndices_i[j] = cumulative;
        cumulative += currEnergySize;
     }
  }
  
  //## end Cluster::calcEngIndices%4044F64A02D6.body
}

std::pair<Real,Real> Cluster::getOptic (int instrument) const
{
  //## begin Cluster::getOptic%4046339B00CB.body preserve=yes
  // This function assumes that all regions of a particular
  // instrument have the same optic axis values.  Therefore,
  // it looks for only the first region it can find and returns
  // that value.
  size_t nReg = m_regions[instrument].size();
  std::pair<Real,Real> optic(.0, .0);
  for (size_t i=0; i<nReg; ++i)
  {
     if (m_regions[instrument][i])
     {
        optic = m_regions[instrument][i]->optic();
        break;
     }
  }
  return optic;
  //## end Cluster::getOptic%4046339B00CB.body
}

bool Cluster::isPixInRegions (int instrument, int ix, int iy) const
{
  //## begin Cluster::isPixInRegions%40463DC1015D.body preserve=yes
  bool isInReg = false;
  int nMapSize = ClusterRegion::instMapSizes()[instrument];
  Real small = 1./32.;
  const std::vector<ClusterRegion*>& regions_i = m_regions[instrument];
  // Note: this function assumes ix, iy are 1-BASED.
  for (size_t j=0; j<regions_i.size(); ++j)
  {
     const ClusterRegion* cr = regions_i[j];
     if (cr)
     {
        if (cr->instMapFractions()[(ix-1) + nMapSize*(iy-1)] > small)
        {
           isInReg = true;
           break;
        }
     }
  }
  return isInReg;
  //## end Cluster::isPixInRegions%40463DC1015D.body
}

void Cluster::calcCoordinates (const Real xoff, const Real yoff, Real& theta, Real& phi)
{
  //## begin Cluster::calcCoordinates%40463E890094.body preserve=yes
  theta = sqrt(xoff*xoff + yoff*yoff);
  if (fabs(xoff) < SMALL)
  {
     phi = 90.;
     if (yoff < .0)
     {
        phi = 270.;
     }
  }
  else
  {
     phi = (180./s_PI)*atan(fabs(yoff)/fabs(xoff));
     if (xoff < .0)
     {
        if (yoff > .0)
        {
           phi += 90.;
        }
        else
        {
           phi += 180.;
        }
     }
     else if (yoff < .0)
     {
        phi += 270.;
     }
  }
  //## end Cluster::calcCoordinates%40463E890094.body
}

Real Cluster::integrateSurfaceBrightness (const Real x, const Real y) const
{
  //## begin Cluster::integrateSurfaceBrightness%4046400F01E1.body preserve=yes
  Real sbint = .0;
  Real powVal = -3.*m_beta + 0.5;
  if (m_sbModelType == 0)
  {
     for (int jx=1; jx<=10; ++jx)
     {
        Real xDist2 = x - ((Real)jx-5.5)*.1;
        xDist2 *= xDist2;
        for (int jy=1; jy<=10; ++jy)
        {
           Real dist2 = xDist2 + (y - ((Real)jy-5.5)*.1)*(y - ((Real)jy-5.5)*.1);
           sbint += .01*pow((1. + dist2/(m_core*m_core)),powVal);
        }
     }
  }
  else if (m_sbModelType == 1)
  {
     for (int jx=1; jx<=10; ++jx)
     {
        Real xDist2 = x - ((Real)jx-5.5)*.1;
        xDist2 *= xDist2;
        for (int jy=1; jy<=10; ++jy)
        {
           Real dist = sqrt(xDist2 + (y - ((Real)jy-5.5)*.1)*(y - ((Real)jy-5.5)*.1))
                        / m_core;
           sbint += .01*(pow(dist,-m_alpha)*exp(-dist) + pow(dist,-m_beta)*
                                (1.-exp(-dist)));
        }
     }
  }
  return sbint;
  //## end Cluster::integrateSurfaceBrightness%4046400F01E1.body
}

int Cluster::findPsfEngBracket (Real energy, int startFrom) const
{
  //## begin Cluster::findPsfEngBracket%404C960702C7.body preserve=yes
  // Given an input energy, this function should find the energies 
  // that bracket it in the m_psfEnergy array.  It returns the index
  // of the lower energy of the bracket.  If energy is less than
  // all energies in the psfArray, it returns -1 (unless startFrom
  // parameter is used). If energy is greater than all psfArray 
  // energies, it returns nPsfe-1.
  
  // If startFrom parameter is used, only begin the search from 
  // index = startFrom.
  int iLowPsfe = (startFrom > 0) ? startFrom-1 : -1;
  int nPsfe = static_cast<int>(m_psfEnergy.size());
  if (energy >= m_psfEnergy[iLowPsfe + 1])
  {
     ++iLowPsfe;
     // iLowPsfe should now = 0, or startFrom, and 
     // energy is >= m_psfEnergy[iLowPsfe].
     while (iLowPsfe < (nPsfe-1) && energy >= m_psfEnergy[iLowPsfe+1])
     {
        ++iLowPsfe;
     }
     // Either m_psfEnergy[iLowPsfe] <= energy < m_psfEnergy[iLowPsfe+1]
     // or m_psfEnergy[nPsfe-1] <= energy.
  }
  return iLowPsfe;
  //## end Cluster::findPsfEngBracket%404C960702C7.body
}

void Cluster::doPerform (GroupFluxContainer& fluxes, bool isError)
{
  //## begin Cluster::doPerform%40522DA20052.body preserve=yes
   size_t nInst = m_regions.size();
   int nReg = m_regions[0].size();
   if (nReg != fluxes.size())
   {
      string msg("Number of regions mismatch in Cluster::doPerform");
      throw RedAlert(msg);
   }
   int nTotE = m_engIndices[nInst-1][nReg];
   // GroupFluxContainer is a map of maps.  The outer map is
   // a collection of regions (data groups), the inner map is
   // a collection of instruments (spectra) for the region.
   GroupFluxContainer tmpFlux(fluxes);
   GroupFluxContainer::iterator t(tmpFlux.begin());
   GroupFluxContainer::iterator tEnd(tmpFlux.end());
   // recall ArrayContainer == std::map<size_t,std::valarray<Real> > so that
   // s->second has a vectorized assignment operator that takes a scalar. 
   while ( t != tEnd )
   {
         ArrayContainer::iterator s (t->second.begin());
         ArrayContainer::iterator sEnd (t->second.end());
         for ( ; s != sEnd; ++s ) s->second = 0;
         ++t;         
   }
   
   for (int inst=0; inst<nInst; ++inst)
   {
      if (m_instInUse[inst])
      {
         for (int jreg=0; jreg<nReg; ++jreg)
         {
            const ClusterRegion* tcr = m_regions[inst][jreg];
            if (tcr)
            {
               int tSpecNum = tcr->spectrumNumber();
               RealArray& targetFlux = tmpFlux[jreg+1][tSpecNum];
               int jOffset = jreg*nTotE;
               for (int ireg=0; ireg<nReg; ++ireg)
               {
                  const ClusterRegion* scr = m_regions[inst][ireg];
                  if (scr)
                  {
                     int sSpecNum = scr->spectrumNumber();
                     RealArray& sourceFlux = fluxes[ireg+1][sSpecNum];
                     int nE = sourceFlux.size();
                     int iOffset = m_engIndices[inst][ireg];
                     for (int ie=0; ie<nE; ++ie)
                     {
                        Real factor = m_factArray[ie + iOffset + jOffset];
                        if (isError)
                        {
                           factor *= factor;
                        }
                        targetFlux[ie] += sourceFlux[ie]*factor;
                     }
                  }
               } // end ireg loop
            }
         } // end jreg loop
      } // end if instInUse
   } // end inst loop
   fluxes = tmpFlux;
  //## end Cluster::doPerform%40522DA20052.body
}

void Cluster::calcGISEfficiency (int inst)
{
  //## begin Cluster::calcGISEfficiency%4057123803C2.body preserve=yes

   // When instrument is the GIS then calculate the efficiency and multiply
   // it into the fact array - assumes that we have the same number of energy
   // bins for each region.
   size_t nInst = m_regions.size();
   int nReg = m_regions[inst].size();
   const ClusterRegion* cr = m_regions[inst][0];
   if (cr)
   {
      size_t specNum = cr->spectrumNumber();
      const RealArray& energy = m_allEnergies.find(1)->second->
                                find(specNum)->second;
      int sz = energy.size();
      const std::vector<int>& engIndices_i = m_engIndices[inst];
      int nTotE = m_engIndices[nInst-1][nReg];
      for (int ie=1; ie<sz; ++ie)
      {
         Real effect = Get_gis_eff(energy[ie-1], energy[ie], 10.7, 0);
         for (int ireg=0; ireg<nReg; ++ireg)
         {
            int iOffset = engIndices_i[ireg] + ie-1;
            for (int jreg=0; jreg<nReg; ++jreg)
            {
               m_factArray[iOffset + nTotE*jreg] *= effect;
            }
         }
      }

   }
  //## end Cluster::calcGISEfficiency%4057123803C2.body
}

bool Cluster::changedParameters (const std::vector<Real>& params) const
{
  //## begin Cluster::changedParameters%40575933004F.body preserve=yes
  return (std::fabs(m_alpha-params[0]) > 1.0e-6 ||
          std::fabs(m_beta-params[1]) > 1.0e-6  ||
          std::fabs(m_core-params[2]) > 1.0e-6  ||
          m_sbModelType != static_cast<int>(params[3]));
  //## end Cluster::changedParameters%40575933004F.body
}

void Cluster::refreshTransform ()
{
  //## begin Cluster::refreshTransform%405B56810188.body preserve=yes
  if (!m_parametersAreFrozen)
  {
     clusterFact();
  }
  //## end Cluster::refreshTransform%405B56810188.body
}

// Additional Declarations
  //## begin Cluster%3F6F1DC503A1.declarations preserve=yes
  //## end Cluster%3F6F1DC503A1.declarations

//## begin module%3F6F20580010.epilog preserve=yes
//## end module%3F6F20580010.epilog
